// LEGEND (X1) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*16*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{

	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int fileno;
	int C;
	int HR;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[FILENAME_MAX];
	unsigned char id1[] = "LEGEND       Sys";
	int i,d,diskno,cyl,hed,sec,size;

	struct fpos md1[] = {
		{ 0x80, 0x09, 0x00, 0x05 },	// [80] PSGhCo
		{ 0x81, 0x09, 0x06, 0x06 },	// [81] OPMhCo
		{ 0x82, 0x09, 0x0D, 0x05 },	// [82]
		{ 0x90, 0x15, 0x08, 0x05 },	// [90]
		{ 0x92, 0x1F, 0x00, 0x02 },	// [92]
		{ 0x99, 0x1E, 0x16, 0x03 },	// [99]
		{ 0x9C, 0x1F, 0x02, 0x02 },	// [9C]
		{ 0xA3, 0x1E, 0x1A, 0x05 },	// [A3]
		{ 0xA5, 0x1F, 0x04, 0x02 },	// [A5]
		{ 0xAC, 0x1E, 0x1F, 0x01 },	// [AC]
		{ 0xAE, 0x1F, 0x06, 0x01 },	// [AE]
		{   -1,  -1,   -1,   -1 },	// end of table
	};

	struct fpos md2[] = {
		// Drive 2
		{ 0xB6, 0x8F, 0x00, 0x01 },	// [B6]
//		{ 0xB7, 0x00, 0x00, 0x00 },	// [B7] 
		{ 0xB9, 0x92, 0x10, 0x05 },	// [B9]
		{ 0xBA, 0x92, 0x15, 0x05 },	// [BA]
//		{ 0xC2, 0x08, 0x00, 0x01 },	// [C2] 
		{   -1, -1,   -1,   -1 },	// end of table
	};

	if (argc != 2) {
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (d=0; d<numdisk; d++) {
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x10);
		// fBXN
		disk.ReadDATA1(0x03, 0x01, 0x01, 0x10, 0x01, buff, 0x100);
		diskno = buff[0];
		switch(diskno) {
		case 0x01:
			printf("DISK 1F܂.\n");
			// CvO
			fcut("BIOS",   0x00, 0x00, 0x00, 0x06, 0x01, 0x0000, 0x0c00);
			// ȃf[^̐؂o
			for (i=0; md1[i].C>0; i++) {
				cyl  = md1[i].C & 0x7f;
				hed  =(md1[i].HR >> 4)&1;
				sec  =(md1[i].HR & 0x0f)+1;
				size = md1[i].size *0x100;
				sprintf(fname,"%02X",md1[i].fileno);
				fcut(fname, cyl*2+hed, cyl, hed, sec, 0x01, 0x00, size);
			}
			continue;

		case 0x02:
			printf("DISK 2F܂.\n");
			for (i=0; md2[i].C>0; i++) {
				cyl  = md2[i].C & 0x7f;
				hed  =(md2[i].HR >> 4)&1;
				sec  =(md2[i].HR & 0x0f)+1;
				size = md2[i].size * 0x100;
				sprintf(fname,"%02X",md2[i].fileno);
				fcut(fname, cyl*2+hed, cyl, hed, sec, 0x01, 0x00, size);
			}
			break;

		default:
			break;
		}
	}
	return 0;
}

